/* SNIFF055.C  (c) Fravia Hacker tools 1990			*/
/* revision_number x110460					*/	
/* sniffs INTERRUPT_CALLS in a dead file		 	*/
/* or, more exactly, all occurrences of the byte "CD" 		*/
/* and all REP(N)Z SCASB & CMPSB				*/
/* to add:
	prolonged byte compare (now: 12) also for CX/CH/CL
        C2xxxx  RET xxxx should take AH off
        C3	RET        "
	switches for REP(N)Z
	only relevant INTS
	other sniffing interests				*/
				
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define TITLE printf("SNIFF v.0.55 (c) Fravia Hacker Tools 1990");
#define LINEZ printf("\n");

void main(int argc, char *argv[])
{
	FILE *fp1;              /* dead file to be sniffed     */
	int ch1, ch2, ch3;      /* single values preceding int */
	int chint;		/* int (AH) value	       */
	int chintAH=0;		/* double for AH               */
   	int chintAL=0;		/* int AL value                */
	int charra[18];         /* byte array preceding int/rep    */
	int repi=0;             /* got a rep(n)z flag	       */
        int jolly=0;		/*              counter        */
	int ii;                 /* 		counter        */
	int intnum=0;           /* int 		counter        */	
	int repznum=0;          /* rep(z)n 	counter        */
	int retnum=0;
	int habemus=0;		/* flag if we found AH         */
	int diffa=0;		/* for filenamepadding         */
	unsigned long l=1;      /* location inside file        */
	unsigned long file_len; /* file length		       */
	unsigned long unquafile;/* 1/4 file length	       */
	char *nominefile;       /* name of the file to sniff   */
	char *result;           /* EXE or COM part	       */
	char *stringorepi;      /* what we write if rep(z)n    */
	char stringodc[45]="";  /* to hold printf() for CD     */
		
/* see if correct number of command line arguments		*/
if(argc!=2) {
	printf("Usage: sniff <file you want to sniff>\n");
	exit(1);         	}

	/*  open file to be sniffed 	*/
	fp1=fopen(argv[1], "rb");
	  if(fp1==NULL) {
		printf("Cannot open file %s\n",argv[1]);
		exit(1);     	}

	/* parse file denomination 	*/
  nominefile= argv[1];
  jolly=strlen(nominefile);
  result = strchr(nominefile,'.');
  /*  if (strcmp(result,".com")== 0) result= ("COM");
    if (strcmp(result,".exe")== 0) result= ("EXE");   */
     	/* print TITLE 			*/	
  printf("\n               ");     /* spaces to center title */
  TITLE
  printf("\n   Ŀ %s ",nominefile);
  for (ii=jolly;ii<=11;ii++) printf(" ");
  printf("Ŀ ");
	/* count length of file 	*/
		fseek(fp1,0L,SEEK_END);
		file_len=ftell(fp1);
                unquafile=file_len/4;	/* for 25... % */

     /* prepare header	*/
	printf(" 0x%lx (%ld) bytes", file_len, file_len);
	printf(" (%s)",result);
     LINEZ
        printf("\ncnt  loc  preced_bytes  sniffd  AL    typ & service");
     LINEZ
     printf("0%");

 fseek(fp1,0,SEEK_SET); 	/* back to beginning */
					/* main loop: search the file 	*/
while(!feof(fp1)) {
ch1=0;      				/* reset chints 	*/
ch2=0;
chint=0;
chintAL=0;
chintAH=0;
repi=0;

	ch1=fgetc(fp1);         /* get next byte and increase pointer */
		if(ferror(fp1))  {
			printf("\nError reading file %s",argv[1]);
			exit(1);		}
		l++;          	          /* advance location   */
	if (l==unquafile)   { LINEZ; printf("25%");}
	if (l==unquafile*2) { LINEZ; printf("50%");}										
	if (l==unquafile*3) { LINEZ; printf("75%");}
      /* ***************** what do we find? *****************   */
                                           /* ****  0xF3 ****   */
   if (ch1== 0xF3) {		/* do we have a F3 REPZ ? 	*/
     ch2=fgetc(fp1);            /* see next byte */
        if (ch2==0xA6) {        /* do we have an A6 CMPSB ? 	*/
          repi=1;
          stringorepi= "REPZ  CMPSB";		}

       if (ch2==0xAE) {        /* do we have an AE SCASB ? 	*/
          repi=1;
          stringorepi= "REPZ  SCASB";		}
        fseek(fp1,l-1,SEEK_SET);
		  } /* end of if ch1= REPZ */

                                           /* ****  0xF2 ****   */
   if (ch1== 0xF2) {		/* do we have a F2 REPNZ ? 	*/
     ch2=fgetc(fp1);
        if (ch2==0xA6) {        /* do we have an A6 CMPSB ? 	*/
          repi=1;
          stringorepi= "REPNZ CMPSB";   	}
        if (ch2==0xAE) {        /* do we have an AE SCASB ? 	*/
          repi=1;
          stringorepi= "REPNZ SCASB";		}
          fseek(fp1,l-1,SEEK_SET);
		  } /* end of if ch1= REPNZ */

                                           /* ****  repi ****   */
if (repi==1) {                       /* got a rep	        */	
 repznum++;			     /* increment counter       */
 printf("\n%03d%6lx",repznum,l+0x8E+0x70);  /* print REP(N)Z loc */

       fseek(fp1,l-13,SEEK_SET);     /* reset position for next array */

  for (ii=0;ii<12;ii++) {         /* create array of bytes preceding rep */
	charra[ii]=fgetc(fp1);   /* and fill it */
  if(ii>=4 && ii<=10) printf("%02X",charra[ii]);  /* print the bytes preceding rep */
  if(ii==11) printf("%02X",charra[ii]);  /* print the byte rep(n)z   */
                         } /* end of array */

	ch1=fgetc(fp1);          /* get byte following rep(n)z */
	printf(" %02X ",ch1);  	   /* print it                 */
        chint=ch1;		   /* hold scasb in chint      */
        l++;                       /* and increment location   */
				   /* Examine preceding bytes  */

  printf("  %s  ", stringorepi);
  habemus=0;
for (ii=10;ii>-1;ii--) {      /* invert search_array        */
                                 /* let's see what we fish     */

  if (charra[ii]==0xB9) {        /* do we have a mov CX ?      */
    ch2=charra[ii+1];            /* then get CH 	       */
    chintAH=ch2;                 /* hold CH in cintAH          */
    ch3=charra[ii+2];
    chintAL=ch3;                 /* hold CL in chintAL         */
    printf("  CX=%02X%02X       ",ch3,ch2);  /* and print them */
    break;		   }
             } /* end search array */
 } /* end if repi ******************************************   */
                 /* ****************************  0xCD *****   */
if (ch1==0xCD) {				 /* have Int   */
    intnum++;				         /* count them */
    fseek(fp1,l-17,SEEK_SET);                    /* reposition stream */
    strcpy(stringodc,"\n%3d%6lx");             /* start stringodc   */

    for (ii=0;ii<16;ii++) {         /* create array of bytes preceding cd */
	charra[ii]=fgetc(fp1);
   if(ii>=8 && ii<=14) strcat(stringodc,"%02X"); /* pamper stringodc */
   if(ii==15) strcat(stringodc,"%02X");         /* pamper stringodc */
                      } /* end of array */


	ch1=fgetc(fp1);            /* get byte following Int (Int_number) */
        chint=ch1;		   /* hold int_number in chint */
        strcat(stringodc," %02X/"); /* pamper stringodc        */
        l++;                       /* and increment location   */
                                   /* print stringodc	       */
printf(stringodc,intnum,(l+0x8E+0x70-1),charra[8], charra[9],
	charra[10], charra[11], charra[12], charra[13], charra[14],
	charra[15], chint);
				 /* Examine preceding bytes    */

 for (ii=14;ii>-1;ii--) {        /* invert search_array        */
                                 /* let's see what we fish     */
                                 /* *****  0xCD  0xB4 ******   */
  if (charra[ii]==0xB4) {        /* do we have a mov AH ?      */
    ch2=charra[ii+1];            /* then get AH 	       */
    chintAH=ch2;                 /* hold AH in cintAH          */
    printf("%02X     ",ch2);    /* and print it               */
    habemus=1;                   /* flag fished	       	       */
    break;		   }
                                 /* *****  0xCD  0xB8 ******   */
  if ((charra[ii]==0xB8) & (ii <=12))
  		        {        /* do we have a mov AX ?       */
        ch3=charra[ii+1];        /* then get AL too             */
        chintAL=ch3;             /* hold AL in chintAL          */
	ch2=charra[ii+2];        /* and get AH                  */
	chintAH=ch2;             /* hold it			*/
  	printf("%02XAL=%02X",ch2,ch3);   /* print AH & AL    */
        habemus=1;               /* flag fished			*/
	break;              }
                                 /* *****  0xCD  0x8A ******   */
  if (charra[ii]==0x8A) {        /* do we have a mov AH[BP+x] ?  */
    if(charra[ii+1]==0x66) {     /* must be AH not AL (0x46)     */
	ch2=charra[ii+2];        /* then get +x                  */
  	printf("[BP+%02X] ",ch2); /* print [BP+x]		 */
        habemus=1;               /* flag fished  		 */
        break;              } /* end m ust be AH */
                         } /* end 0x8A */
                                /* *****  0x32E4 ******   */
  if (charra[ii]==0x32) {        /* do we have a xor AH,AH ?  */
    if(charra[ii+1]==0xE4) {     /* must be AH     */
        ch2=0;
	chintAH=ch2;               /* then get AH                  */
  	printf("%02X     ",ch2);      /* and print it	 */
        habemus=1;               /* flag fished  		 */
        break;              } /* end must be AH */
                         } /* end 0x32E4 */
                                /* *****  0x33C0 ******   */
  if (charra[ii]==0x33) {        /* do we have a xor AX,AX ?  */
    if(charra[ii+1]==0xC0) {     /* must be AX     */
        ch2=0;
        ch3=0;
	chintAH=ch2;               /* then get AH                  */
        chintAL=ch3;
  	printf("%02XAL=%02X",ch2,ch3);       /* and print it	 */
        habemus=1;               /* flag fished  		 */
        break;              } /* end must be AX */
                         } /* end 0x33C0 */
             } /* end of for reverse loop */
        if (habemus==0) printf("       ");    /* nice display */
        habemus=0;                               /* reset flag   */

                       /* now let's notify the user about the ints */
     switch (chint) {
     case 0x01:
     	printf(" sstp");
        break;
     case 0x03:
     	printf (" debg");
        break;
     case 0x08:
     	printf (" time");
        break;
     case 0x09:
     	printf (" KYB9");
        break;
     case 0x10:
     	printf (" VID ");
        retnum=3;		     /* flag 0x10 */
        break;
     case 0x13:
        printf ("DISKREAD !");
        retnum=4;                    /* flag 0x13 */
        break;
     case 0x16:
     	printf (" KYB ");
        retnum=2;		     /* flag 0x16 */	
        break;
     case 0x20:
     	printf (" TERMINATE");
        break;
     case 0x21:
     	printf (" DOS ");
        retnum=1;                     /* flag 0x21 */
        break;
     case 0x22:
     	printf(" term");
        break;
     case 0x23:
     	printf (" CTRC");
        break;
     case 0x24:
     	printf ("Fatal");
        break;
     case 0x27:
     	printf (" TSR");
        break;
     case 0x67:
     	printf ("LIM/EMS");
        break;
     default:
     	printf("  -  ");
         } /* end of switch on INT_number */


if (retnum==4) {		/* yeah, we have a DISK call    **/
   switch(chintAH){

       case 0x00:
        printf ("Reset floppy");
        break;
       case 0x01:
        printf ("Get floppy status");
        break;
       case 0x02:
        printf ("Read %xscs CHtrk CLsec >ES:BX",chintAL);
        break;
       case 0x03:
        printf ("Write %xscs >CHtrk CLsec", chintAL);
        break;
       case 0x04:
        printf ("Vrify %xscs CHtrk CLsec", chintAL);
        break;
       case 0x13:
        printf ("Format disk track");
        break;
       default:
        printf ("  -  ");
         }  /* end switch */
        retnum=0;
       } /* end if retnum==4 */

if (retnum==3) {		/* yeah, we have a Video call    */
   switch(chintAH){
       case 0x00:
        printf ("Set video mode");
        break;
       case 0x01:
        printf ("Set cursor chars");
        break;
       case 0x02:
        printf ("Set cursor pos");
        break;
       case 0x03:
        printf ("Read cursor pos");
        break;
       case 0x05:
        printf ("Select display page");
        break;
       case 0x06:
        printf ("wdw scroll lines>%x<0=blank)",chintAL);
        break;
       case 0x08:
        printf ("Read attr/char at cursor");
        break;
       case 0x09:
        printf ("Write attr/char at cursor");
        break;
       case 0x13:
        printf ("Write string");
        break;
       case 0x6A:
        printf ("Direct Graphic IS");
        break;
       default:
        printf ("  -  ");
         }  /* end switch */
        retnum=0;
       } /* end if retnum==2 */

if (retnum==2) {		/* yeah, we have a Keyboard call    **/
   switch(chintAH){

       case 0x00:
        printf ("Read char");
        break;
       case 0x01:
        printf ("Check buffer");
        break;
       case 0x02:
        printf ("Get shift status");
        break;
       case 0x03:
        printf ("Set delays");
        break;
       case 0x04:
        printf ("Keyclick");
        break;
       case 0x05:
        printf ("Write to keyb buf");
        break;
       case 0x10:
        printf ("Get enhanced keystr");
        break;
       case 0x11:
        printf ("Check enhanced keystr");
        break;
       case 0x12:
        printf ("Get enhanced shift flags");
        break;
       default:
        printf ("  -  ");
         }  /* end switch */
        retnum=0;
       } /* end if retnum==2 */

if (retnum==1) {   		/* yeah, we have a DOS service call */     		
   switch(chintAH) {            /* switch to service	*/
        case 0x00:
         printf ("Program terminate");
         break;
        case 0x01:
         printf ("Char input");
         break;
        case 0x02:
         printf ("Char output");
         break;
        case 0x06:
         printf ("Direct I/O");
         break;
        case 0x07:
         printf ("Reads Kybrd char");
         break;
        case 0x08:
         printf ("Reads Kybrd char");
         break;
        case 0x09:
         printf ("Print string DS:DX");
         break;
        case 0x0B:
         printf ("Check stdrd input");
         break;
        case 0x0D:
         printf ("Disk reset");
         break;
        case 0x0E:
         printf ("Select Disk DL");
         break;
        case 0x0F:
         printf ("Open file DS:DX");
         break;
        case 0x10:
         printf ("Close file DS:DX");
         break;
        case 0x14:
         printf ("Seq read file DS:DX");
         break;
        case 0x15:
         printf ("Seq write file DS:DX");
         break;
        case 0x19:
         printf ("Get dflt dsk_n");
         break;
        case 0x1A:
         printf ("Set DTA at DS:DX");
         break;
        case 0x21:
         printf ("Rnd_read rcd");
         break;
        case 0x22:
         printf ("Rnd_wrt dsk");
         break;
        case 0x25:
         printf ("HOOK int %x (at DS:DX)", chintAL);
         break;
        case 0x26:
         printf ("Create PSP at seg_DX");
         break;
        case 0x29:
         printf ("Parse Filename flag %d", chintAL);
         break;
        case 0x2A:
         printf ("Get date");
         break;   	
        case 0x2B:
         printf ("Set date DL/DH/CX");
         break;
        case 0x2C:
         printf ("Get time");
         break;   	
        case 0x2D:
         printf ("Set time CH:CL:DH:DL");
         break;
        case 0x2F:
         printf ("Get DTA");
         break;
        case 0x30:
         printf ("Get DOS ver");
         break;
        case 0x31:
         printf ("TSR with ret_code %d", chintAL);
         break;
        case 0x32:
         printf ("Get drv DL param_block!");
         break;
        case 0x33:
         printf ("gt/st C_brk state DL=0=Off");
         break;
   	case 0x34:
         printf ("Indos ptr");
         break;
    	case 0x35:
     	 printf ("get int_vect %d", chintAL);
     	 break;
        case 0x38:
         printf ("gt/st ctry_inf [%d 0=gt]", chintAL);
         break;
        case 0x3C:
         printf ("Create file CX at DS:DX");
         break;
        case 0x3D:
         printf ("Open file DS:DX acc=%x", chintAL);
         break;
        case 0x3E:
         printf ("Close file BX");
         break;
        case 0x3F:
         printf ("Read from file BX > DS:DX");
         break;
        case 0x40:
         printf ("Write DS:DX > to file BX");
         break;
	case 0x41:
	 printf ("Delete file DS:DX");
	 break;
	case 0x42:
         printf ("LSEEK %d <0beg 1cur 2end", chintAL);
         break;
        case 0x43:
         printf ("get/set f_attr %x<get=0", chintAL);
         break;
        case 0x44:
         printf ("IOCTL %x<get:0246", chintAL);
         break;
        case 0x47:
         printf ("Get current dir");
         break;
   	case 0x48:
         printf ("MEMALLOC BX parr");
         break;
        case 0x49:
         printf ("FREEMEM seg ES");
         break;
        case 0x4A:
         printf ("SETBLOCK seg ES, newsize BX");
         break;
        case 0x4B:
         printf ("EXEC %x<0=ld+ex1=ld3=ld ovl", chintAL);
         break;
   	case 0x4C:
         printf ("EXIT_w_return code %x", chintAL);
         break;   	
   	case 0x4D:
         printf ("Get child exit code");
         break;   	
        case 0x4E:
         printf ("FINDFIRST match");
         break;
        case 0x4F:
         printf ("FINDNEXT match");
         break;
        case 0x50:
         printf ("Set PSP Seg");
         break;
        case 0x51:
         printf ("GET PSP Seg");
         break;
   	case 0x52:
         printf ("LstOfLst > ES:BX");
         break;
        case 0x54:
         printf ("get vrfy flag");
         break;
        case 0x56:
         printf ("rename file ds:dx to es:di");
         break;
         case 0x57:
         printf ("Unknown");
        case 0x58:
         printf ("gt/st mem_strat");
         break;
        case 0x66:
         printf ("gt/st glbl_code pg_tb");
         break;
        case 0x67:
         printf ("set handle count");
         break;

        default:
         printf (" - ");
          } /* end of switch on AH */
     retnum=0;    	/* reset flag */
      } /* end of if retnum=1 */

    } /* end of if 'cd' */
  } /* end of while !feof(fp1) */

        fclose(fp1);
        LINEZ
        printf("100%");   	
        printf("\n                 ");

      /* just to silence tc */
         diffa++;

}  /* end of main */
